<?php
// Copyright 2006 Won-Kyu Park <wkpark at kldp.org>
// All rights reserved. Distributable under GPL see COPYING
// a bug track system plugin for the MoniWiki
//
// $Id$

include_once("lib/metadata.php");

function _get_btsConfig($raw) {
    $meta='';
    $body=&$raw;
    while(true) {
        list($line,$body)=explode("\n",$body,2);
        if ($line[0]=='#') continue;
        if (strpos($line,':')===false or trim($line)=='') break;
        $meta.=$line."\n";
    }

    return getMetadata($meta,1);
}

function processor_bts($formatter,$value='',$options='') {
    global $DBInfo;

    if ($value[0]=='#' and $value[1]=='!')
        list($arg,$value)=explode("\n",$value,2);
    if ($arg) {
        # get parameters
        list($tag, $user, $date, $title)=explode(" ",$line, 4);

        if (preg_match('/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/',$user))
        $user="Anonymous[$user]";

        if ($date && $date[10] == 'T') {
            $date[10]=' ';
            $time=strtotime($date." GMT");
            $date= "@ ".date("Y-m-d [h:i a]",$time);
        }
    }

    $bts_conf='BugTrack/Config';
    if ($DBInfo->hasPage($bts_conf)) {
        $p=new WikiPage($bts_conf);
        $config_raw=$p->get_raw_body();
        $confs=_get_btsConfig($config_raw);
        #print_r($confs);
    }
    
    $body=$value;
    # parse metadata
    $meta='';
    while(true) {
        list($line,$body)=explode("\n",$body,2);
        if ($line[0]=='#') continue;
        if (strpos($line,':')===false or trim($line)=='') break;
        $meta.=$line."\n";
    }

    $metas=getMetadata($meta);
    $head="##.col1\n";
    $colnum=2;
    foreach ($metas as $k=>$v) {
        $kk=$k;
        if (in_array($k,array('Version','Component'))) {
            $kk=str_replace(' ','-',ucwords($metas['Product'])).'-'.$k;
        }
        if ($confs[$kk]) {
            $v='[[InputForm('.str_replace($v,$v.' 1',$confs[$kk]).')]]';
        }
        if ($k[0]=='X' and $k[1]=='-') {
            $k=substr($k,2);
            if ($k=='Separator') {
                $head.="\n##\n\n##.col$colnum\n";
                $colnum++;
            } else
                $head.="|| ''".$k."'' || ".$v." ||\n";
        } else
            $head.="|| '''".$k."''' || ".$v." ||\n";
    }
    $head.="\n##\n====\n[[InputForm(submit:Save Changes)]]\n\n";

    if ($body) {
        $options['nosisters']=1;
        ob_start();

        # add some basic rule/repl for bts

        $rule="/----\nComment-Id:\s*(\d+)\n".
            "From:\s*([^\n]+)\nDate:\s*([^\n]+)\n\n/im";
        $repl="----\n'''Comment-Id:''' [#c\\1][#c\\1 #\\1] by \\2 on [[DateTime(\\3)]] ![reply]\n\n";
        $body=preg_replace($rule,$repl,$body);

        $formatter->quote_style='bts-comment';
        $options['usemeta']=1;

        #
        $formatter->baserule[]="/^((-=)+-?$)/";
        $formatter->baserule[]="/ comment #(\d+)\b/";
        $formatter->baserule[]="/Bug #?(\d+)\b/";

        $formatter->baserepl[]="<hr />\n";
        $formatter->baserepl[]=" comment [#c\\1 #\\1]";
        $formatter->baserepl[]="wiki:BugTrack:\\1";

        #
        $formatter->send_page($head.$body,$options);
        $msg= ob_get_contents();
        ob_end_clean();

    }

    return $msg;
}

// vim:et:sts=4::
?>
